// bszip.cpp : .DLL initialization

#include "stdafx.h"
#include "bszip.h"

FARPROC lpfn_zCloseZipFile			= NULL;	// 1
FARPROC lpfn_zOpenZipFile			= NULL;	// 2
FARPROC lpfn_zGetLastErrorAsText	= NULL;	// 3
FARPROC lpfp_zGetTotalFiles			= NULL;	// 4
FARPROC lpfp_zGetTotalBytes			= NULL;	// 5
FARPROC lpfp_zGetSelectedFiles		= NULL;	// 6
FARPROC lpfp_zGetSelectedBytes		= NULL;	// 7
FARPROC lpfp_zGetSkippedFiles		= NULL;	// 8
FARPROC lpfp_zGetRunTimeInfo		= NULL;	// 9
FARPROC lpfp_zCancelOperation		= NULL;	//10
FARPROC lpfp_zExtractOne			= NULL;	//11
FARPROC lpfp_zExtractSelected		= NULL;	//12
FARPROC lpfp_zExtractAll			= NULL;	//13
FARPROC lpfn_zGetFileName			= NULL;	//14
FARPROC lpfn_zGetFileExt			= NULL;	//15
FARPROC lpfn_zGetFilePath			= NULL;	//16
FARPROC lpfn_zGetFileDate			= NULL;	//17
FARPROC lpfn_zGetFileTime			= NULL;	//18
FARPROC lpfn_zGetFileSize			= NULL;	//19
FARPROC lpfn_zGetCompressedFileSize	= NULL;	//20
FARPROC lpfn_zFileIsEncrypted		= NULL;	//21
FARPROC lpfn_zGetLastOperResult		= NULL;	//22
FARPROC lpfn_zFileIsSelected		= NULL;	//23
FARPROC lpfn_zSelectFile			= NULL;	//24
FARPROC lpfn_zCompressFiles			= NULL;	//25
FARPROC lpfn_zOrderFile				= NULL;	//26
FARPROC lpfn_zCreateNewZip			= NULL;	//27

FARPROC lpfn_zUnselectAll			= NULL;	//28
FARPROC lpfn_zSelectByWildcards		= NULL;	//29
FARPROC lpfn_zOrderByWildcards		= NULL;	//30
FARPROC lpfn_zDeleteFiles			= NULL;	//31
FARPROC lpfn_zGetOrderedFiles		= NULL;	//32
FARPROC lpfn_zGetOrderedBytes		= NULL;	//33
FARPROC lpfn_zGetComment			= NULL;	//34
FARPROC lpfn_zIsSpanned 			= NULL;	//35


struct bszip_DLL
{
	bszip_DLL()
	{
		m_hLib = LoadLibrary("bszip.dll");

		if(m_hLib == NULL) {
			::MessageBox(NULL,"Unable to load bszip.dll","ERROR",MB_OK);
			exit(-1);
			return;
		}

		VERIFY(lpfn_zCloseZipFile				= GetProcAddress(m_hLib,"zCloseZipFile"));
		VERIFY(lpfn_zOpenZipFile				= GetProcAddress(m_hLib,"zOpenZipFile"));
		VERIFY(lpfn_zGetLastErrorAsText			= GetProcAddress(m_hLib,"zGetLastErrorAsText"));
		VERIFY(lpfp_zGetTotalFiles				= GetProcAddress(m_hLib,"zGetTotalFiles"));
		VERIFY(lpfp_zGetTotalBytes				= GetProcAddress(m_hLib,"zGetTotalBytes"));
		VERIFY(lpfp_zGetSelectedFiles			= GetProcAddress(m_hLib,"zGetSelectedFiles"));
		VERIFY(lpfp_zGetSelectedBytes			= GetProcAddress(m_hLib,"zGetSelectedBytes"));
		VERIFY(lpfp_zGetSkippedFiles			= GetProcAddress(m_hLib,"zGetSkippedFiles"));
		VERIFY(lpfp_zGetRunTimeInfo				= GetProcAddress(m_hLib,"zGetRunTimeInfo"));
		VERIFY(lpfp_zCancelOperation			= GetProcAddress(m_hLib,"zCancelOperation"));
		VERIFY(lpfp_zExtractOne					= GetProcAddress(m_hLib,"zExtractOne"));
		VERIFY(lpfp_zExtractSelected			= GetProcAddress(m_hLib,"zExtractSelected"));
		VERIFY(lpfp_zExtractAll					= GetProcAddress(m_hLib,"zExtractAll"));
		VERIFY(lpfn_zGetFileName				= GetProcAddress(m_hLib,"zGetFileName"));
		VERIFY(lpfn_zGetFileExt					= GetProcAddress(m_hLib,"zGetFileExt"));
		VERIFY(lpfn_zGetFilePath				= GetProcAddress(m_hLib,"zGetFilePath"));
		VERIFY(lpfn_zGetFileDate				= GetProcAddress(m_hLib,"zGetFileDate"));
		VERIFY(lpfn_zGetFileTime				= GetProcAddress(m_hLib,"zGetFileTime"));
		VERIFY(lpfn_zGetFileSize				= GetProcAddress(m_hLib,"zGetFileSize"));
		VERIFY(lpfn_zGetCompressedFileSize		= GetProcAddress(m_hLib,"zGetCompressedFileSize"));
		VERIFY(lpfn_zFileIsEncrypted			= GetProcAddress(m_hLib,"zFileIsEncrypted"));
		VERIFY(lpfn_zGetLastOperResult			= GetProcAddress(m_hLib,"zGetLastOperResult"));
		VERIFY(lpfn_zFileIsSelected				= GetProcAddress(m_hLib,"zFileIsSelected"));
		VERIFY(lpfn_zSelectFile					= GetProcAddress(m_hLib,"zSelectFile"));
		VERIFY(lpfn_zCompressFiles				= GetProcAddress(m_hLib,"zCompressFiles"));
		VERIFY(lpfn_zOrderFile					= GetProcAddress(m_hLib,"zOrderFile"));
		VERIFY(lpfn_zCreateNewZip				= GetProcAddress(m_hLib,"zCreateNewZip"));

		VERIFY(lpfn_zUnselectAll				= GetProcAddress(m_hLib,"zUnselectAll"));
		VERIFY(lpfn_zSelectByWildcards			= GetProcAddress(m_hLib,"zSelectByWildcards"));
		VERIFY(lpfn_zOrderByWildcards			= GetProcAddress(m_hLib,"zOrderByWildcards"));
		VERIFY(lpfn_zDeleteFiles				= GetProcAddress(m_hLib,"zDeleteFiles"));
		VERIFY(lpfn_zGetOrderedFiles			= GetProcAddress(m_hLib,"zGetOrderedFiles"));
		VERIFY(lpfn_zGetOrderedBytes			= GetProcAddress(m_hLib,"zGetOrderedBytes"));
		VERIFY(lpfn_zGetComment 				= GetProcAddress(m_hLib,"zGetComment"));
		VERIFY(lpfn_zIsSpanned  				= GetProcAddress(m_hLib,"zIsSpanned"));

	}

	~bszip_DLL()
	{
		if(m_hLib)
			FreeLibrary(m_hLib);
	}

	HINSTANCE m_hLib;
};

bszip_DLL bszip_dll;


int zCloseZipFile(void)
{
	if(!bszip_dll.m_hLib || !lpfn_zCloseZipFile)
		return -1;
	return ((int (__stdcall *)(void))lpfn_zCloseZipFile)();
}

int zOpenZipFile(char *zipfilename)
{
	if(!bszip_dll.m_hLib || !lpfn_zOpenZipFile)
		return -1;
	return ((int (__stdcall *)(char*))lpfn_zOpenZipFile)(zipfilename);
}

char*	zGetLastErrorAsText(void)
{
	if(!bszip_dll.m_hLib || !lpfn_zGetLastErrorAsText)
		return NULL;
	return ((char* (__stdcall *)(void))lpfn_zGetLastErrorAsText)();
}

int zGetTotalFiles(void)
{
	if(!bszip_dll.m_hLib || !lpfp_zGetTotalFiles)
		return -1;
	return ((int (__stdcall *)(void))lpfp_zGetTotalFiles)();
}

int zGetTotalBytes(void)
{
	if(!bszip_dll.m_hLib || !lpfp_zGetTotalBytes)
		return -1;
	return ((int (__stdcall *)(void))lpfp_zGetTotalBytes)();
}

int zGetSelectedFiles(void)
{
	if(!bszip_dll.m_hLib || !lpfp_zGetSelectedFiles)
		return -1;
	return ((int (__stdcall *)(void))lpfp_zGetSelectedFiles)();
}

int zGetSelectedBytes(void)
{
	if(!bszip_dll.m_hLib || !lpfp_zGetSelectedBytes)
		return -1;
	return ((int (__stdcall *)(void))lpfp_zGetSelectedBytes)();
}

int zGetSkippedFiles(void)
{
	if(!bszip_dll.m_hLib || !lpfp_zGetSkippedFiles)
		return -1;
	return ((int (__stdcall *)(void))lpfp_zGetSkippedFiles)();
}

BOOL zGetRunTimeInfo(int &ProcessedFiles,int &ProcessedBytes)
{
	if(!bszip_dll.m_hLib || !lpfp_zGetRunTimeInfo)
		return FALSE;
	return ((BOOL (__stdcall *)(int&,int&))lpfp_zGetRunTimeInfo)(ProcessedFiles,ProcessedBytes);
}

BOOL zCancelOperation(void)
{
	if(!bszip_dll.m_hLib || !lpfp_zCancelOperation)
		return FALSE;
	return ((BOOL (__stdcall *)(void))lpfp_zCancelOperation)();
}

int zExtractOne(int ItemNo,char *ExtractDirectory,char *Password,BOOL OverwriteExisting, BOOL SkipOlder, BOOL UseFolders,BOOL TestOnly,fn_prototype_RTInfo RTInfoFunc)
{
	if(!bszip_dll.m_hLib || !lpfp_zExtractOne)
		return -1;
	return ((int (__stdcall *)(int,char*,char*,BOOL, BOOL, BOOL,BOOL,fn_prototype_RTInfo))lpfp_zExtractOne)(ItemNo,ExtractDirectory,Password,OverwriteExisting, SkipOlder, UseFolders,TestOnly,RTInfoFunc);
}

int zExtractSelected(char *ExtractDirectory,char *Password,BOOL OverwriteExisting, BOOL SkipOlder, BOOL UseFolders,BOOL TestOnly,fn_prototype_RTInfo RTInfoFunc)
{
	if(!bszip_dll.m_hLib || !lpfp_zExtractSelected)
		return -1;
	return ((int (__stdcall *)(char*,char*,BOOL, BOOL, BOOL,BOOL,fn_prototype_RTInfo))lpfp_zExtractSelected)(ExtractDirectory,Password,OverwriteExisting, SkipOlder, UseFolders,TestOnly,RTInfoFunc);
}

int zExtractAll(char *ExtractDirectory,char *Password,BOOL OverwriteExisting, BOOL SkipOlder, BOOL UseFolders,BOOL TestOnly,fn_prototype_RTInfo RTInfoFunc)
{
	if(!bszip_dll.m_hLib || !lpfp_zExtractAll)
		return -1;
	return ((int (__stdcall *)(char*,char*,BOOL, BOOL, BOOL,BOOL,fn_prototype_RTInfo))lpfp_zExtractAll)(ExtractDirectory,Password,OverwriteExisting, SkipOlder, UseFolders,TestOnly,RTInfoFunc);
}

char* zGetFileName(int index)
{
	if(!bszip_dll.m_hLib || !lpfn_zGetFileName)
		return NULL;
	return ((char* (__stdcall *)(int))lpfn_zGetFileName)(index);
}

char* zGetFileExt(int index)
{
	if(!bszip_dll.m_hLib || !lpfn_zGetFileExt)
		return NULL;
	return ((char* (__stdcall *)(int))lpfn_zGetFileExt)(index);
}

char* zGetFilePath(int index)
{
	if(!bszip_dll.m_hLib || !lpfn_zGetFilePath)
		return NULL;
	return ((char* (__stdcall *)(int))lpfn_zGetFilePath)(index);
}

int zGetFileDate(int index)
{
	if(!bszip_dll.m_hLib || !lpfn_zGetFileDate)
		return -1;
	return ((int (__stdcall *)(int))lpfn_zGetFileDate)(index);
}

int zGetFileTime(int index)
{
	if(!bszip_dll.m_hLib || !lpfn_zGetFileTime)
		return -1;
	return ((int (__stdcall *)(int))lpfn_zGetFileTime)(index);
}

int zGetFileSize(int index)
{
	if(!bszip_dll.m_hLib || !lpfn_zGetFileSize)
		return -1;
	return ((int (__stdcall *)(int))lpfn_zGetFileSize)(index);
}

int zGetCompressedFileSize(int index)
{
	if(!bszip_dll.m_hLib || !lpfn_zGetCompressedFileSize)
		return -1;
	return ((int (__stdcall *)(int))lpfn_zGetCompressedFileSize)(index);
}

BOOL zFileIsEncrypted(int index)
{
	if(!bszip_dll.m_hLib || !lpfn_zFileIsEncrypted)
		return FALSE;
	return ((BOOL (__stdcall *)(int))lpfn_zFileIsEncrypted)(index);
}

char* zGetLastOperResult(int index)
{
	if(!bszip_dll.m_hLib || !lpfn_zGetLastOperResult)
		return NULL;
	return ((char* (__stdcall *)(int))lpfn_zGetLastOperResult)(index);
}

BOOL zFileIsSelected(int index)
{
	if(!bszip_dll.m_hLib || !lpfn_zFileIsSelected)
		return FALSE;
	return ((BOOL (__stdcall *)(int))lpfn_zFileIsSelected)(index);
}

BOOL zSelectFile(int index,BOOL how)
{
	if(!bszip_dll.m_hLib || !lpfn_zSelectFile)
		return FALSE;
	return ((BOOL (__stdcall *)(int,BOOL))lpfn_zSelectFile)(index,how);
}

int zCompressFiles(char *TempDir, char *Password, int CompressionMethod, BOOL ResetArchiveAttribute,  int SpanSize, char *Comment, fn_prototype_RTInfo RTInfoFunc)
{
	if(!bszip_dll.m_hLib || !lpfn_zCompressFiles)
		return -1;
	return ((int (__stdcall *)(char*,char*,int,BOOL, int, char*, fn_prototype_RTInfo))lpfn_zCompressFiles)(TempDir,Password,CompressionMethod,ResetArchiveAttribute, SpanSize, Comment, RTInfoFunc);
}

int zOrderFile(char *FileName, char *StoredName, int UpdateMode)
{
	if(!bszip_dll.m_hLib || !lpfn_zOrderFile)
		return -1;
	return ((int (__stdcall *)(char*,char*,int))lpfn_zOrderFile)(FileName,StoredName,UpdateMode);
}

int zCreateNewZip(char *ZipFileName)
{
	if(!bszip_dll.m_hLib || !lpfn_zCreateNewZip)
		return -1;
	return ((int (__stdcall *)(char *))lpfn_zCreateNewZip)(ZipFileName);
}








BOOL zUnselectAll(void)
{
	if(!bszip_dll.m_hLib || !lpfn_zUnselectAll)
		return FALSE;
	return ((BOOL (__stdcall *)(void))lpfn_zUnselectAll)();
}


int zSelectByWildcards(char *FileMask,BOOL IncludeSubfolders)
{
	if(!bszip_dll.m_hLib || !lpfn_zSelectByWildcards)
		return -1;
	return ((int (__stdcall *)(char *, BOOL))lpfn_zSelectByWildcards)(FileMask, IncludeSubfolders);
}


int zOrderByWildcards(char *FileMask, char *BasePath, BOOL IncludeSubfolders, BOOL CheckArchiveAttribute, int UpdateMode)
{
	if(!bszip_dll.m_hLib || !lpfn_zOrderByWildcards)
		return -1;
	return ((int (__stdcall *)(char *, char *, BOOL, BOOL, int))lpfn_zOrderByWildcards)(FileMask, BasePath, IncludeSubfolders, CheckArchiveAttribute, UpdateMode);
}


int zDeleteFiles(void)
{
	if(!bszip_dll.m_hLib || !lpfn_zDeleteFiles)
		return -1;
	return ((int (__stdcall *)(void))lpfn_zDeleteFiles)();
}


int zGetOrderedFiles(void)
{
	if(!bszip_dll.m_hLib || !lpfn_zGetOrderedFiles)
		return -1;
	return ((int (__stdcall *)(void))lpfn_zGetOrderedFiles)();
}


int zGetOrderedBytes(void)
{
	if(!bszip_dll.m_hLib || !lpfn_zGetOrderedBytes)
		return -1;
	return ((int (__stdcall *)(void))lpfn_zGetOrderedBytes)();
}


char* zGetComment(void)
{
	if(!bszip_dll.m_hLib || !lpfn_zGetComment)
		return NULL;
	return ((char* (__stdcall *)(void))lpfn_zGetComment)();
}


BOOL zIsSpanned(void)
{
	if(!bszip_dll.m_hLib || !lpfn_zIsSpanned)
		return FALSE;
	return ((BOOL (__stdcall *)(void))lpfn_zIsSpanned)();
}











